function [y]=schurprec_forw(x,A,Bp,Fp,Mp,Kp)
% Right triangular version of the Commmutator Schur complement for a single spatial
% problem. Velocity block is solved by HSL
global avoid_hsl_prec

nv = size(A,1);
np = size(Bp,2);

y2 = Mp\x(nv+1:nv+np);
y2 = Fp*y2;
y2 = Kp\y2;
y1 = Bp*y2;
y1 = y1+x(1:nv);
if (~isempty(avoid_hsl_prec))&&(~avoid_hsl_prec)
    y1 = hsl_mi20_precondition(y1);
else
    y1 = A\y1;
end;
y = [y1; -y2];
end

